#include <stdio.h>
#include <malloc.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>

int h2d( char c)
{
   if ( c >= '0' && c <= '9' ) return c - '0';
   if ( c >= 'A' && c <= 'F' ) return c - 'A' + 10;
   if ( c >= 'a' && c <= 'f' ) return c - 'a' + 10;

   printf( "SHOULD NOT OCCUR !!!\n" );
   exit(1);
}

void FinDeFichier()
{
printf("=======> REACHED END OF FILE...\n");
exit(0);
}

int main( )
{
   int c;
   int n;
   int s;
   int t_nom, t_fic;

   int num=0;
   char n_out[1024];
   FILE *out;

   while(1)
   {
      t_nom = t_fic = 0;

      for(n=0;n<54;++n)
      {
         if(getchar()==EOF) FinDeFichier();
      }

      printf( "Taille du fichier : ");
      for(n=0;n<8;++n)
      {
         c=getchar();
	 t_fic = t_fic * 16 + h2d( c );
	 printf("%c", c);
      }
      printf(" (%d)\n", t_fic);

      for(n=0;n<32;++n)
      {
         if(getchar()==EOF) FinDeFichier();
      }

      printf( "Taille du nom : ");
      for(n=0;n<8;++n)
      {
         c=getchar();
	 t_nom = t_nom * 16 + h2d( c );
	 printf("%c", c);
      }
      printf(" (%d)\n", t_nom);

if(t_nom>48)
{
printf( "Le nom a l air trop long !\n");
exit(1);
}

      for(n=0;n<8;++n)
      {
         if(getchar()==EOF) FinDeFichier();
      }

      sprintf( n_out, "Out/%08d.name", num );
      out = fopen( n_out, "w" );

      printf( "Nom du fichier : " );
      for(n=0;n<t_nom-1;++n)
      {
         c=getchar();
	 printf("%c", c);
	 fputc( c, out );
      }
      fclose( out );
      printf( "\n");

/*
      s=0;
      c=getchar(); while( c == 0 ) { c=getchar(); ++s; }
      ungetc( c, stdin );
      printf( "Name : Skipped %d NULLs	(%d => %d)\n", s, t_nom, s);
*/
s=(t_nom+1)%4;
s=4-s;
printf( "Name : Skipping %d NULLs (%d => %d)\n", s, t_nom, s);

for(;s>0;--s) 
{
   c=getchar();
   if(c!=0)
   {
      printf( "SHOULD NOT OCCUR ! %s %d\n", __FILE__, __LINE__ );
      exit(1);
   }
}
      sprintf( n_out, "Out/%08d.content", num );
      out = fopen( n_out, "w" );

      for(n=0;n<t_fic;++n)
      {
	 c = getchar();
	 fputc( c, out );
      }
      fclose(out );


      s=0;
      c=getchar(); while( c == 0 ) { c=getchar(); ++s; }
      ungetc( c, stdin );
      printf( "Content : Skipped %d NULLs (%d => %d)\n", s, t_fic, s);

      ++num; // next file
   }
}
